// BufferOutputStream
// Writes data to a byte array instead of an actual stream, for later use.
// Grabs the puts method from LineOutputStream
import java.io.*;

public class BufferOutputStream extends LineOutputStream
{
	public byte array[];
	public int length;

	// construct an empty stream.
	BufferOutputStream()
	{
	clear();
	}

	// getarray
	// Returns an array of only the data sent to this buffer
	byte []getarray()
	{
	byte a[] = new byte[length];
	System.arraycopy(array, 0, a, 0, length);
	return a;
	}

	// clear
	// Clear the output array
	public void clear()
	{
	array = new byte[10];
	length = 0;
	}

	// write
	// Add one byte to the array
	public void write(int b)
	{
	if (length == array.length)
		doublearray();
	array[length++] = (byte)b;
	}

	// write
	// Add an array of bytes
	public void write(byte b[])
	{
	write(b, 0, b.length);
	}

	// write
	// Add part of an array of bytes
	public void write(byte b[], int off, int len)
	{
	while(length + len >= array.length)
		doublearray();
	System.arraycopy(b, off, array, length, len);
	length += len;
	}

	public void flush() {}

	public void close() {}

	// doublearray
	// Reallocate the array to twice it's original size
	void doublearray()
	{
	byte n[] = new byte[array.length*2];
	System.arraycopy(array, 0, n, 0, array.length);
	array = n;
	}
}
