// RenameFile
// Given two filenames in the JFS filesystem, rename one to the other. The
// new file will by owned by the given user.
import java.io.*;

public class RenameFile
{
	public static void main(String argv[])
	{
	if (argv.length !=  4)
		die("usage: java RenameFile <JFS root> <old> <new> <user>");
	FileSystem.init(argv[0]);
	JFSserver.loadcache();

	// rename it
	try { FileSystem.rename(argv[1], argv[2], argv[3]); }
	catch(BadPathException e) {
		die("Error renaming "+argv[1]+" to "+argv[2]+" : "+
		    e.getMessage());
		}
	}

	// die
	// Print a message and exit
	static void die(String msg)
	{
	System.err.println(msg);
	System.exit(1);
	}
}

